#include <stdio.h>
#include <stdlib.h>
#include <math.h>

// Macros to plot primitives
#define plot(x,y,r,g,b) printf("0,%d,%d,%d,%d,%d\n",x,y,r,g,b)
#define line(x1,y1,x2,y2,r,g,b) printf("1,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define rect(x1,y1,x2,y2,r,g,b) printf("2,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define fillrect(x1,y1,x2,y2,r,g,b) printf("3,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define circle(x1,y1,x2,y2,r,g,b) printf("4,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define fillcircle(x1,y1,x2,y2,r,g,b) printf("5,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define ellipse(x1,y1,x2,y2,r,g,b) printf("6,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)
#define fillellipse(x1,y1,x2,y2,r,g,b) printf("7,%d,%d,%d,%d,%d,%d,%d",x1,y1,x2,y2,r,g,b)

// You can be certain that in doAction,
// x1<x2 && y1<y2

void doAction(int x1,int y1,int x2,int y2,int r,int g,int b);
int min(int a,int b);
int max(int a,int b);

int main(int argc,char *argv[])
{
int x1,x2,y1,y2,r,g,b;

if (argc!=8)
	{
	fprintf(stderr,"\nWrong number of args\n\n");
	exit(-1);
	}

x1 = atoi(argv[1]);
y1 = atoi(argv[2]);
x2 = atoi(argv[3]);
y2 = atoi(argv[4]);
r  = atoi(argv[5]);
g  = atoi(argv[6]);
b  = atoi(argv[7]);

doAction(min(x1,x2),min(y1,y2),max(x1,x2),max(y1,y2),r,g,b);

return 1;
} // end main

int max(int a,int b)
{
if (a>b) return a;
else return b;
}

int min(int a,int b)
{
if (a<b) return a;
else return b;
}

void doAction(int x1,int y1,int x2,int y2,int r,int g,int b)
{
// simple example, output rubbish

int x,y;

for(x=x1;x<x2;x++)
for(y=y1;y<y2;y++)
plot(x,y,rand()%65535,rand()%65535,rand()%65535);
} // end do something
